const DistanceResovler = require('./DistanceResolver.js')

/*
  * This is a free key with 2500 requests per day restriction. Ideally this would
  * have been stored in a separate location (not stored under VCS) like in CI
  * deployment secrets storage. For simplicity's sake I left it here so that
  * code will actually work.
  */
const apiKey = '58d904a497c67e00015b45fc711d2a70bece433faf282bd510515061'
const rp = require('request-promise-native')

class OpenRouteMapDistanceResolver extends DistanceResovler {
/**
 * Gets (route) distance between point A and point B
 * @param {Number[]} A - array [longitude, latitude]
 * @param {Number[]} B - array [longitude, latitude]
 * @returns {Return Promise<Number>} distance between points in meters
 */
  getDistance (A, B) {
    // profile profile drive-car gives "can't find point" for some locations, i suppose the ones that are not reachable via car
    return rp(`https://api.openrouteservice.org/directions?api_key=${apiKey}&coordinates=${A.join(',')}%7C${B.join(',')}&profile=foot-walking`)
      .then(JSON.parse)
      // in case there are no routes between points assume there's really no route.
      // i'm not sure if that's how it works tho
      .then(response => response.routes.length === 0 ? Number.POSITIVE_INFINITY : response.routes[0].summary.distance)
  }
}

// Just a test
// (new OpenRouteMapDistanceResolver()).getDistance([8.685755, 49.393505], [8.686141, 49.389643]).then(console.log)
// Should be around 430

module.exports = OpenRouteMapDistanceResolver
