require('chai').should()
describe('SimpleDistanceResolver', function () {
  const simpleDistanceResolver = new (require('./SimpleDistanceResolver.js'))()

  describe('getDistance', async function () {
    it('short distance', async function () {
      // Some points on straight road and distance provided by OpenRouteService
      // so output of our function should relatively match the expectations
      const A = [8.685755, 49.393505]
      const B = [8.686141, 49.389643]
      const realDist = 432

      const distance = await simpleDistanceResolver.getDistance(A, B)
      distance.should.be.closeTo(realDist, 5)
    })

    it('long distance', async function () {
      // Some points on some very long straight road in USA and distance provided by OpenRouteService
      // so output of our function should relatively match the expectations
      const A = [-99.358635, 35.84109]
      const B = [-99.35885, 35.725646]
      const realDist = 12834

      const distance = await simpleDistanceResolver.getDistance(A, B)
      distance.should.be.closeTo(realDist, 5)
    })
  })
})
